package org.mavok.common

import org.mavok.api.column.AbstractColumn

import scala.language.implicitConversions

case class DynamicTuple[+T](elements: Vector[T] ){}


object BaseMapper extends DynamicTupleMapper[AbstractColumn[_, _], AbstractColumn[_, _]] {

  implicit def baseDynamicTuple[T1 <: AbstractColumn[_, _]](t: (T1 ) ): DynamicTuple[T1] = new DynamicTuple[T1](t.elements)
  implicit def base2DynamicTuple[Super <: AbstractColumn[_, _],T1 <: Super , T2 <: Super](t: (T1, T2) ): DynamicTuple[Super] = {
      new DynamicTuple[Super](t._1.elements ++ t._2.elements)
  }
  implicit def base3DynamicTuple[Super <: AbstractColumn[_, _], T1 <: Super, T2 <: Super, T3 <: Super](t: (T1, T2, T3  ) ): DynamicTuple[Super] = {
    new DynamicTuple[Super](t._1.elements ++ t._2.elements ++ t._3.elements)
  }
}


class DynamicTupleMapper[LowerBound, +UpperBound <: LowerBound ] {


  protected implicit def element[Element <: LowerBound, T >: UpperBound <: Element](element: T): DynamicTuple[Element] = new DynamicTuple[Element](Vector[Element](element))


  protected def tupleDynamicTuple[Element <: LowerBound, T1 >: UpperBound <: Element](t: (T1)): DynamicTuple[Element] =
    new DynamicTuple[Element](t.elements)

  protected def tuple2DynamicTuple[Element <: LowerBound, T1 >: UpperBound <: Element, T2 >: UpperBound <: Element](t: (T1, T2)): DynamicTuple[Element] =
    new DynamicTuple[Element](t._1.elements ++ t._2.elements)

  protected def tuple3DynamicTuple[Element <: LowerBound, T1 >: UpperBound <: Element, T2 >: UpperBound <: Element, T3 >: UpperBound <: Element](t: (T1, T2, T3)): DynamicTuple[Element] =
    new DynamicTuple[Element](t._1.elements ++ t._2.elements ++ t._3.elements)

}
/*
  def tuple4DynamicTuple[Element <: LowerBound, T1 >: UpperBound <: Element, T2 >: UpperBound <: Element , T3 >: UpperBound <: Element , T4 >: UpperBound <: Element ](t: (T1, T2, T3, T4))
                                                (ev1: T1 => DynamicTuple[T1], ev2: T2 => DynamicTuple[T2], ev3: T3 => DynamicTuple[T3], ev4: T4 => DynamicTuple[T4]): DynamicTuple[Element] =
    new DynamicTuple[Element](t._1.columns ++ t._2.columns ++ t._3.columns ++ t._4.columns)

  def tuple5DynamicTuple[Element <: LowerBound, T1 >: UpperBound <: Element, T2 >: UpperBound <: Element , T3 >: UpperBound <: Element , T4 >: UpperBound <: Element , T5 >: UpperBound <: Element ](t: (T1, T2, T3, T4, T5))
                                                     (ev1: T1 => DynamicTuple[T1], ev2: T2 => DynamicTuple[T2], ev3: T3 => DynamicTuple[T3], ev4: T4 => DynamicTuple[T4], ev5: T5 => DynamicTuple[T5]): DynamicTuple[Element] =
    new DynamicTuple[Element](t._1.columns ++ t._2.columns ++ t._3.columns ++ t._4.columns ++ t._5.columns)

  def tuple6DynamicTuple[Element <: LowerBound, T1 >: UpperBound <: Element, T2 >: UpperBound <: Element , T3 >: UpperBound <: Element , T4 >: UpperBound <: Element , T5 >: UpperBound <: Element , T6 >: UpperBound <: Element ](t: (T1, T2, T3, T4, T5, T6))
                                                          (ev1: T1 => DynamicTuple[T1], ev2: T2 => DynamicTuple[T2], ev3: T3 => DynamicTuple[T3], ev4: T4 => DynamicTuple[T4], ev5: T5 => DynamicTuple[T5], ev6: T6 => DynamicTuple[T6]): DynamicTuple[Element] =
    new DynamicTuple[Element](t._1.columns ++ t._2.columns ++ t._3.columns ++ t._4.columns ++ t._5.columns ++ t._6.columns)

  def tuple7DynamicTuple[Element <: LowerBound, T1 >: UpperBound <: Element, T2 >: UpperBound <: Element , T3 >: UpperBound <: Element , T4 >: UpperBound <: Element , T5 >: UpperBound <: Element , T6 >: UpperBound <: Element , T7 >: UpperBound <: Element ](t: (T1, T2, T3, T4, T5, T6, T7))
                                                               (ev1: T1 => DynamicTuple[T1], ev2: T2 => DynamicTuple[T2], ev3: T3 => DynamicTuple[T3], ev4: T4 => DynamicTuple[T4], ev5: T5 => DynamicTuple[T5], ev6: T6 => DynamicTuple[T6], ev7: T7 => DynamicTuple[T7]): DynamicTuple[Element] =
    new DynamicTuple[Element](t._1.columns ++ t._2.columns ++ t._3.columns ++ t._4.columns ++ t._5.columns ++ t._6.columns ++ t._7.columns)

  def tuple8DynamicTuple[Element <: LowerBound, T1 >: UpperBound <: Element, T2 >: UpperBound <: Element , T3 >: UpperBound <: Element , T4 >: UpperBound <: Element , T5 >: UpperBound <: Element , T6 >: UpperBound <: Element , T7 >: UpperBound <: Element , T8 >: UpperBound <: Element ](t: (T1, T2, T3, T4, T5, T6, T7, T8))
                                                                    (ev1: T1 => DynamicTuple[T1], ev2: T2 => DynamicTuple[T2], ev3: T3 => DynamicTuple[T3], ev4: T4 => DynamicTuple[T4], ev5: T5 => DynamicTuple[T5], ev6: T6 => DynamicTuple[T6], ev7: T7 => DynamicTuple[T7], ev8: T8 => DynamicTuple[T8]): DynamicTuple[Element] =
    new DynamicTuple[Element](t._1.columns ++ t._2.columns ++ t._3.columns ++ t._4.columns ++ t._5.columns ++ t._6.columns ++ t._7.columns ++ t._8.columns)

  def tuple9DynamicTuple[Element <: LowerBound, T1 >: UpperBound <: Element, T2 >: UpperBound <: Element , T3 >: UpperBound <: Element , T4 >: UpperBound <: Element , T5 >: UpperBound <: Element , T6 >: UpperBound <: Element , T7 >: UpperBound <: Element , T8 >: UpperBound <: Element , T9 >: UpperBound <: Element ](t: (T1, T2, T3, T4, T5, T6, T7, T8, T9))
                                                                         (ev1: T1 => DynamicTuple[T1], ev2: T2 => DynamicTuple[T2], ev3: T3 => DynamicTuple[T3], ev4: T4 => DynamicTuple[T4], ev5: T5 => DynamicTuple[T5], ev6: T6 => DynamicTuple[T6], ev7: T7 => DynamicTuple[T7], ev8: T8 => DynamicTuple[T8], ev9: T9 => DynamicTuple[T9]): DynamicTuple[Element] =
    new DynamicTuple[Element](t._1.columns ++ t._2.columns ++ t._3.columns ++ t._4.columns ++ t._5.columns ++ t._6.columns ++ t._7.columns ++ t._8.columns ++ t._9.columns)

  def tuple10DynamicTuple[Element <: LowerBound, T1 >: UpperBound <: Element, T2 >: UpperBound <: Element , T3 >: UpperBound <: Element , T4 >: UpperBound <: Element , T5 >: UpperBound <: Element , T6 >: UpperBound <: Element , T7 >: UpperBound <: Element , T8 >: UpperBound <: Element , T9 >: UpperBound <: Element , T10 >: UpperBound <: Element ](t: (T1, T2, T3, T4, T5, T6, T7, T8, T9, T10))
                                                                                (ev1: T1 => DynamicTuple[T1], ev2: T2 => DynamicTuple[T2], ev3: T3 => DynamicTuple[T3], ev4: T4 => DynamicTuple[T4], ev5: T5 => DynamicTuple[T5], ev6: T6 => DynamicTuple[T6], ev7: T7 => DynamicTuple[T7], ev8: T8 => DynamicTuple[T8], ev9: T9 => DynamicTuple[T9], ev10: T10 => DynamicTuple[T10]): DynamicTuple[Element] =
    new DynamicTuple[Element](t._1.columns ++ t._2.columns ++ t._3.columns ++ t._4.columns ++ t._5.columns ++ t._6.columns ++ t._7.columns ++ t._8.columns ++ t._9.columns ++ t._10.columns)

  def tuple11DynamicTuple[Element <: LowerBound, T1 >: UpperBound <: Element, T2 >: UpperBound <: Element , T3 >: UpperBound <: Element , T4 >: UpperBound <: Element , T5 >: UpperBound <: Element , T6 >: UpperBound <: Element , T7 >: UpperBound <: Element , T8 >: UpperBound <: Element , T9 >: UpperBound <: Element , T10 >: UpperBound <: Element , T11 >: UpperBound <: Element ](t: (T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11))
                                                                                      (ev1: T1 => DynamicTuple[T1], ev2: T2 => DynamicTuple[T2], ev3: T3 => DynamicTuple[T3], ev4: T4 => DynamicTuple[T4], ev5: T5 => DynamicTuple[T5], ev6: T6 => DynamicTuple[T6], ev7: T7 => DynamicTuple[T7], ev8: T8 => DynamicTuple[T8], ev9: T9 => DynamicTuple[T9], ev10: T10 => DynamicTuple[T10], ev11: T11 => DynamicTuple[T11]): DynamicTuple[Element] =
    new DynamicTuple[Element](t._1.columns ++ t._2.columns ++ t._3.columns ++ t._4.columns ++ t._5.columns ++ t._6.columns ++ t._7.columns ++ t._8.columns ++ t._9.columns ++ t._10.columns ++ t._11.columns)

  def tuple12DynamicTuple[Element <: LowerBound, T1 >: UpperBound <: Element, T2 >: UpperBound <: Element , T3 >: UpperBound <: Element , T4 >: UpperBound <: Element , T5 >: UpperBound <: Element , T6 >: UpperBound <: Element , T7 >: UpperBound <: Element , T8 >: UpperBound <: Element , T9 >: UpperBound <: Element , T10 >: UpperBound <: Element , T11 >: UpperBound <: Element , T12 >: UpperBound <: Element ](t: (T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12))
                                                                                            (ev1: T1 => DynamicTuple[T1], ev2: T2 => DynamicTuple[T2], ev3: T3 => DynamicTuple[T3], ev4: T4 => DynamicTuple[T4], ev5: T5 => DynamicTuple[T5], ev6: T6 => DynamicTuple[T6], ev7: T7 => DynamicTuple[T7], ev8: T8 => DynamicTuple[T8], ev9: T9 => DynamicTuple[T9], ev10: T10 => DynamicTuple[T10], ev11: T11 => DynamicTuple[T11], ev12: T12 => DynamicTuple[T12]): DynamicTuple[Element] =
    new DynamicTuple[Element](t._1.columns ++ t._2.columns ++ t._3.columns ++ t._4.columns ++ t._5.columns ++ t._6.columns ++ t._7.columns ++ t._8.columns ++ t._9.columns ++ t._10.columns ++ t._11.columns ++ t._12.columns)

  def tuple13DynamicTuple[Element <: LowerBound, T1 >: UpperBound <: Element, T2 >: UpperBound <: Element , T3 >: UpperBound <: Element , T4 >: UpperBound <: Element , T5 >: UpperBound <: Element , T6 >: UpperBound <: Element , T7 >: UpperBound <: Element , T8 >: UpperBound <: Element , T9 >: UpperBound <: Element , T10 >: UpperBound <: Element , T11 >: UpperBound <: Element , T12 >: UpperBound <: Element , T13 >: UpperBound <: Element ](t: (T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12, T13))
                                                                                                  (ev1: T1 => DynamicTuple[T1], ev2: T2 => DynamicTuple[T2], ev3: T3 => DynamicTuple[T3], ev4: T4 => DynamicTuple[T4], ev5: T5 => DynamicTuple[T5], ev6: T6 => DynamicTuple[T6], ev7: T7 => DynamicTuple[T7], ev8: T8 => DynamicTuple[T8], ev9: T9 => DynamicTuple[T9], ev10: T10 => DynamicTuple[T10], ev11: T11 => DynamicTuple[T11], ev12: T12 => DynamicTuple[T12], ev13: T13 => DynamicTuple[T13]): DynamicTuple[Element] =
    new DynamicTuple[Element](t._1.columns ++ t._2.columns ++ t._3.columns ++ t._4.columns ++ t._5.columns ++ t._6.columns ++ t._7.columns ++ t._8.columns ++ t._9.columns ++ t._10.columns ++ t._11.columns ++ t._12.columns ++ t._13.columns)

  def tuple14DynamicTuple[Element <: LowerBound, T1 >: UpperBound <: Element, T2 >: UpperBound <: Element , T3 >: UpperBound <: Element , T4 >: UpperBound <: Element , T5 >: UpperBound <: Element , T6 >: UpperBound <: Element , T7 >: UpperBound <: Element , T8 >: UpperBound <: Element , T9 >: UpperBound <: Element , T10 >: UpperBound <: Element , T11 >: UpperBound <: Element , T12 >: UpperBound <: Element , T13 >: UpperBound <: Element , T14 >: UpperBound <: Element ](t: (T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12, T13, T14))
                                                                                                        (ev1: T1 => DynamicTuple[T1], ev2: T2 => DynamicTuple[T2], ev3: T3 => DynamicTuple[T3], ev4: T4 => DynamicTuple[T4], ev5: T5 => DynamicTuple[T5], ev6: T6 => DynamicTuple[T6], ev7: T7 => DynamicTuple[T7], ev8: T8 => DynamicTuple[T8], ev9: T9 => DynamicTuple[T9], ev10: T10 => DynamicTuple[T10], ev11: T11 => DynamicTuple[T11], ev12: T12 => DynamicTuple[T12], ev13: T13 => DynamicTuple[T13], ev14: T14 => DynamicTuple[T14]): DynamicTuple[Element] =
    new DynamicTuple[Element](t._1.columns ++ t._2.columns ++ t._3.columns ++ t._4.columns ++ t._5.columns ++ t._6.columns ++ t._7.columns ++ t._8.columns ++ t._9.columns ++ t._10.columns ++ t._11.columns ++ t._12.columns ++ t._13.columns ++ t._14.columns)

  def tuple15DynamicTuple[Element <: LowerBound, T1 >: UpperBound <: Element, T2 >: UpperBound <: Element , T3 >: UpperBound <: Element , T4 >: UpperBound <: Element , T5 >: UpperBound <: Element , T6 >: UpperBound <: Element , T7 >: UpperBound <: Element , T8 >: UpperBound <: Element , T9 >: UpperBound <: Element , T10 >: UpperBound <: Element , T11 >: UpperBound <: Element , T12 >: UpperBound <: Element , T13 >: UpperBound <: Element , T14 >: UpperBound <: Element , T15 >: UpperBound <: Element ](t: (T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12, T13, T14, T15))
                                                                                                              (ev1: T1 => DynamicTuple[T1], ev2: T2 => DynamicTuple[T2], ev3: T3 => DynamicTuple[T3], ev4: T4 => DynamicTuple[T4], ev5: T5 => DynamicTuple[T5], ev6: T6 => DynamicTuple[T6], ev7: T7 => DynamicTuple[T7], ev8: T8 => DynamicTuple[T8], ev9: T9 => DynamicTuple[T9], ev10: T10 => DynamicTuple[T10], ev11: T11 => DynamicTuple[T11], ev12: T12 => DynamicTuple[T12], ev13: T13 => DynamicTuple[T13], ev14: T14 => DynamicTuple[T14], ev15: T15 => DynamicTuple[T15]): DynamicTuple[Element] =
    new DynamicTuple[Element](t._1.columns ++ t._2.columns ++ t._3.columns ++ t._4.columns ++ t._5.columns ++ t._6.columns ++ t._7.columns ++ t._8.columns ++ t._9.columns ++ t._10.columns ++ t._11.columns ++ t._12.columns ++ t._13.columns ++ t._14.columns ++ t._15.columns)

  def tuple16DynamicTuple[Element <: LowerBound, T1 >: UpperBound <: Element, T2 >: UpperBound <: Element , T3 >: UpperBound <: Element , T4 >: UpperBound <: Element , T5 >: UpperBound <: Element , T6 >: UpperBound <: Element , T7 >: UpperBound <: Element , T8 >: UpperBound <: Element , T9 >: UpperBound <: Element , T10 >: UpperBound <: Element , T11 >: UpperBound <: Element , T12 >: UpperBound <: Element , T13 >: UpperBound <: Element , T14 >: UpperBound <: Element , T15 >: UpperBound <: Element , T16 >: UpperBound <: Element ](t: (T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12, T13, T14, T15, T16))
      (ev1: T1 => DynamicTuple[T1], ev2: T2 => DynamicTuple[T2], ev3: T3 => DynamicTuple[T3], ev4: T4 => DynamicTuple[T4], ev5: T5 => DynamicTuple[T5], ev6: T6 => DynamicTuple[T6], ev7: T7 => DynamicTuple[T7], ev8: T8 => DynamicTuple[T8], ev9: T9 => DynamicTuple[T9], ev10: T10 => DynamicTuple[T10], ev11: T11 => DynamicTuple[T11], ev12: T12 => DynamicTuple[T12], ev13: T13 => DynamicTuple[T13], ev14: T14 => DynamicTuple[T14], ev15: T15 => DynamicTuple[T15], ev16: T16 => DynamicTuple[T16]): DynamicTuple[Element] =
    new DynamicTuple[Element](t._1.columns ++ t._2.columns ++ t._3.columns ++ t._4.columns ++ t._5.columns ++ t._6.columns ++ t._7.columns ++ t._8.columns ++ t._9.columns ++ t._10.columns ++ t._11.columns ++ t._12.columns ++ t._13.columns ++ t._14.columns ++ t._15.columns ++ t._16.columns)

  def tuple17DynamicTuple[Element <: LowerBound, T1 >: UpperBound <: Element, T2 >: UpperBound <: Element , T3 >: UpperBound <: Element , T4 >: UpperBound <: Element , T5 >: UpperBound <: Element , T6 >: UpperBound <: Element , T7 >: UpperBound <: Element , T8 >: UpperBound <: Element , T9 >: UpperBound <: Element , T10 >: UpperBound <: Element , T11 >: UpperBound <: Element , T12 >: UpperBound <: Element , T13 >: UpperBound <: Element , T14 >: UpperBound <: Element , T15 >: UpperBound <: Element , T16 >: UpperBound <: Element , T17 >: UpperBound <: Element ](t: (T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12, T13, T14, T15, T16, T17))
                                                                                                                          (ev1: T1 => DynamicTuple[T1], ev2: T2 => DynamicTuple[T2], ev3: T3 => DynamicTuple[T3], ev4: T4 => DynamicTuple[T4], ev5: T5 => DynamicTuple[T5], ev6: T6 => DynamicTuple[T6], ev7: T7 => DynamicTuple[T7], ev8: T8 => DynamicTuple[T8], ev9: T9 => DynamicTuple[T9], ev10: T10 => DynamicTuple[T10], ev11: T11 => DynamicTuple[T11], ev12: T12 => DynamicTuple[T12], ev13: T13 => DynamicTuple[T13], ev14: T14 => DynamicTuple[T14], ev15: T15 => DynamicTuple[T15], ev16: T16 => DynamicTuple[T16], ev17: T17 => DynamicTuple[T17]): DynamicTuple[Element] =
    new DynamicTuple[Element](t._1.columns ++ t._2.columns ++ t._3.columns ++ t._4.columns ++ t._5.columns ++ t._6.columns ++ t._7.columns ++ t._8.columns ++ t._9.columns ++ t._10.columns ++ t._11.columns ++ t._12.columns ++ t._13.columns ++ t._14.columns ++ t._15.columns ++ t._16.columns ++ t._17.columns)

  def tuple18DynamicTuple[Element <: LowerBound, T1 >: UpperBound <: Element, T2 >: UpperBound <: Element , T3 >: UpperBound <: Element , T4 >: UpperBound <: Element , T5 >: UpperBound <: Element , T6 >: UpperBound <: Element , T7 >: UpperBound <: Element , T8 >: UpperBound <: Element , T9 >: UpperBound <: Element , T10 >: UpperBound <: Element , T11 >: UpperBound <: Element , T12 >: UpperBound <: Element , T13 >: UpperBound <: Element , T14 >: UpperBound <: Element , T15 >: UpperBound <: Element , T16 >: UpperBound <: Element , T17 >: UpperBound <: Element , T18 >: UpperBound <: Element ](t: (T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12, T13, T14, T15, T16, T17, T18))
                                                                                                                                (ev1: T1 => DynamicTuple[T1], ev2: T2 => DynamicTuple[T2], ev3: T3 => DynamicTuple[T3], ev4: T4 => DynamicTuple[T4], ev5: T5 => DynamicTuple[T5], ev6: T6 => DynamicTuple[T6], ev7: T7 => DynamicTuple[T7], ev8: T8 => DynamicTuple[T8], ev9: T9 => DynamicTuple[T9], ev10: T10 => DynamicTuple[T10], ev11: T11 => DynamicTuple[T11], ev12: T12 => DynamicTuple[T12], ev13: T13 => DynamicTuple[T13], ev14: T14 => DynamicTuple[T14], ev15: T15 => DynamicTuple[T15], ev16: T16 => DynamicTuple[T16], ev17: T17 => DynamicTuple[T17], ev18: T18 => DynamicTuple[T18]): DynamicTuple[Element] =
    new DynamicTuple[Element](t._1.columns ++ t._2.columns ++ t._3.columns ++ t._4.columns ++ t._5.columns ++ t._6.columns ++ t._7.columns ++ t._8.columns ++ t._9.columns ++ t._10.columns ++ t._11.columns ++ t._12.columns ++ t._13.columns ++ t._14.columns ++ t._15.columns ++ t._16.columns ++ t._17.columns ++ t._18.columns)

  def tuple19DynamicTuple[Element <: LowerBound, T1 >: UpperBound <: Element, T2 >: UpperBound <: Element , T3 >: UpperBound <: Element , T4 >: UpperBound <: Element , T5 >: UpperBound <: Element , T6 >: UpperBound <: Element , T7 >: UpperBound <: Element , T8 >: UpperBound <: Element , T9 >: UpperBound <: Element , T10 >: UpperBound <: Element , T11 >: UpperBound <: Element , T12 >: UpperBound <: Element , T13 >: UpperBound <: Element , T14 >: UpperBound <: Element , T15 >: UpperBound <: Element , T16 >: UpperBound <: Element , T17 >: UpperBound <: Element , T18 >: UpperBound <: Element , T19 >: UpperBound <: Element ](t: (T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12, T13, T14, T15, T16, T17, T18, T19))
                                                                                                                                      (ev1: T1 => DynamicTuple[T1], ev2: T2 => DynamicTuple[T2], ev3: T3 => DynamicTuple[T3], ev4: T4 => DynamicTuple[T4], ev5: T5 => DynamicTuple[T5], ev6: T6 => DynamicTuple[T6], ev7: T7 => DynamicTuple[T7], ev8: T8 => DynamicTuple[T8], ev9: T9 => DynamicTuple[T9], ev10: T10 => DynamicTuple[T10], ev11: T11 => DynamicTuple[T11], ev12: T12 => DynamicTuple[T12], ev13: T13 => DynamicTuple[T13], ev14: T14 => DynamicTuple[T14], ev15: T15 => DynamicTuple[T15], ev16: T16 => DynamicTuple[T16], ev17: T17 => DynamicTuple[T17], ev18: T18 => DynamicTuple[T18], ev19: T19 => DynamicTuple[T19]): DynamicTuple[Element] =
    new DynamicTuple[Element](t._1.columns ++ t._2.columns ++ t._3.columns ++ t._4.columns ++ t._5.columns ++ t._6.columns ++ t._7.columns ++ t._8.columns ++ t._9.columns ++ t._10.columns ++ t._11.columns ++ t._12.columns ++ t._13.columns ++ t._14.columns ++ t._15.columns ++ t._16.columns ++ t._17.columns ++ t._18.columns ++ t._19.columns)

  def tuple20DynamicTuple[Element <: LowerBound, T1 >: UpperBound <: Element, T2 >: UpperBound <: Element , T3 >: UpperBound <: Element , T4 >: UpperBound <: Element , T5 >: UpperBound <: Element , T6 >: UpperBound <: Element , T7 >: UpperBound <: Element , T8 >: UpperBound <: Element , T9 >: UpperBound <: Element , T10 >: UpperBound <: Element , T11 >: UpperBound <: Element , T12 >: UpperBound <: Element , T13 >: UpperBound <: Element , T14 >: UpperBound <: Element , T15 >: UpperBound <: Element , T16 >: UpperBound <: Element , T17 >: UpperBound <: Element , T18 >: UpperBound <: Element , T19 >: UpperBound <: Element , T20 >: UpperBound <: Element ](t: (T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12, T13, T14, T15, T16, T17, T18, T19, T20))
                                                                                                                                            (ev1: T1 => DynamicTuple[T1], ev2: T2 => DynamicTuple[T2], ev3: T3 => DynamicTuple[T3], ev4: T4 => DynamicTuple[T4], ev5: T5 => DynamicTuple[T5], ev6: T6 => DynamicTuple[T6], ev7: T7 => DynamicTuple[T7], ev8: T8 => DynamicTuple[T8], ev9: T9 => DynamicTuple[T9], ev10: T10 => DynamicTuple[T10], ev11: T11 => DynamicTuple[T11], ev12: T12 => DynamicTuple[T12], ev13: T13 => DynamicTuple[T13], ev14: T14 => DynamicTuple[T14], ev15: T15 => DynamicTuple[T15], ev16: T16 => DynamicTuple[T16], ev17: T17 => DynamicTuple[T17], ev18: T18 => DynamicTuple[T18], ev19: T19 => DynamicTuple[T19], ev20: T20 => DynamicTuple[T20]): DynamicTuple[Element] =
    new DynamicTuple[Element](t._1.columns ++ t._2.columns ++ t._3.columns ++ t._4.columns ++ t._5.columns ++ t._6.columns ++ t._7.columns ++ t._8.columns ++ t._9.columns ++ t._10.columns ++ t._11.columns ++ t._12.columns ++ t._13.columns ++ t._14.columns ++ t._15.columns ++ t._16.columns ++ t._17.columns ++ t._18.columns ++ t._19.columns ++ t._20.columns)

  def tuple21DynamicTuple[Element <: LowerBound, T1 >: UpperBound <: Element, T2 >: UpperBound <: Element , T3 >: UpperBound <: Element , T4 >: UpperBound <: Element , T5 >: UpperBound <: Element , T6 >: UpperBound <: Element , T7 >: UpperBound <: Element , T8 >: UpperBound <: Element , T9 >: UpperBound <: Element , T10 >: UpperBound <: Element , T11 >: UpperBound <: Element , T12 >: UpperBound <: Element , T13 >: UpperBound <: Element , T14 >: UpperBound <: Element , T15 >: UpperBound <: Element , T16 >: UpperBound <: Element , T17 >: UpperBound <: Element , T18 >: UpperBound <: Element , T19 >: UpperBound <: Element , T20 >: UpperBound <: Element , T21 >: UpperBound <: Element ](t: (T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12, T13, T14, T15, T16, T17, T18, T19, T20, T21))
                                                                                                                                                  (ev1: T1 => DynamicTuple[T1], ev2: T2 => DynamicTuple[T2], ev3: T3 => DynamicTuple[T3], ev4: T4 => DynamicTuple[T4], ev5: T5 => DynamicTuple[T5], ev6: T6 => DynamicTuple[T6], ev7: T7 => DynamicTuple[T7], ev8: T8 => DynamicTuple[T8], ev9: T9 => DynamicTuple[T9], ev10: T10 => DynamicTuple[T10], ev11: T11 => DynamicTuple[T11], ev12: T12 => DynamicTuple[T12], ev13: T13 => DynamicTuple[T13], ev14: T14 => DynamicTuple[T14], ev15: T15 => DynamicTuple[T15], ev16: T16 => DynamicTuple[T16], ev17: T17 => DynamicTuple[T17], ev18: T18 => DynamicTuple[T18], ev19: T19 => DynamicTuple[T19], ev20: T20 => DynamicTuple[T20], ev21: T21 => DynamicTuple[T21]): DynamicTuple[Element] =
    new DynamicTuple[Element](t._1.columns ++ t._2.columns ++ t._3.columns ++ t._4.columns ++ t._5.columns ++ t._6.columns ++ t._7.columns ++ t._8.columns ++ t._9.columns ++ t._10.columns ++ t._11.columns ++ t._12.columns ++ t._13.columns ++ t._14.columns ++ t._15.columns ++ t._16.columns ++ t._17.columns ++ t._18.columns ++ t._19.columns ++ t._20.columns ++ t._21.columns)

  def tuple22DynamicTuple[Element <: LowerBound, T1 >: UpperBound <: Element, T2 >: UpperBound <: Element , T3 >: UpperBound <: Element , T4 >: UpperBound <: Element , T5 >: UpperBound <: Element , T6 >: UpperBound <: Element , T7 >: UpperBound <: Element , T8 >: UpperBound <: Element , T9 >: UpperBound <: Element , T10 >: UpperBound <: Element , T11 >: UpperBound <: Element , T12 >: UpperBound <: Element , T13 >: UpperBound <: Element , T14 >: UpperBound <: Element , T15 >: UpperBound <: Element , T16 >: UpperBound <: Element , T17 >: UpperBound <: Element , T18 >: UpperBound <: Element , T19 >: UpperBound <: Element , T20 >: UpperBound <: Element , T21 >: UpperBound <: Element , T22 >: UpperBound <: Element ](t: (T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12, T13, T14, T15, T16, T17, T18, T19, T20, T21, T22))
                                                                                                                                                        (ev1: T1 => DynamicTuple[T1], ev2: T2 => DynamicTuple[T2], ev3: T3 => DynamicTuple[T3], ev4: T4 => DynamicTuple[T4], ev5: T5 => DynamicTuple[T5], ev6: T6 => DynamicTuple[T6], ev7: T7 => DynamicTuple[T7], ev8: T8 => DynamicTuple[T8], ev9: T9 => DynamicTuple[T9], ev10: T10 => DynamicTuple[T10], ev11: T11 => DynamicTuple[T11], ev12: T12 => DynamicTuple[T12], ev13: T13 => DynamicTuple[T13], ev14: T14 => DynamicTuple[T14], ev15: T15 => DynamicTuple[T15], ev16: T16 => DynamicTuple[T16], ev17: T17 => DynamicTuple[T17], ev18: T18 => DynamicTuple[T18], ev19: T19 => DynamicTuple[T19], ev20: T20 => DynamicTuple[T20], ev21: T21 => DynamicTuple[T21], ev22: T22 => DynamicTuple[T22]): DynamicTuple[Element] =
    new DynamicTuple[Element](t._1.columns ++ t._2.columns ++ t._3.columns ++ t._4.columns ++ t._5.columns ++ t._6.columns ++ t._7.columns ++ t._8.columns ++ t._9.columns ++ t._10.columns ++ t._11.columns ++ t._12.columns ++ t._13.columns ++ t._14.columns ++ t._15.columns ++ t._16.columns ++ t._17.columns ++ t._18.columns ++ t._19.columns ++ t._20.columns ++ t._21.columns ++ t._22.columns)

}
*/
